{-# LANGUAGE GADTs #-}
{-# LANGUAGE FunctionalDependencies #-}
module Functions where

import Types
import Sources

class (SourceState a, Show f) => IsF f a b | f -> a b where
  runF :: f -> a -> b

data IsImageFilename = IsImageFilename deriving (Show)
instance IsF IsImageFilename FilePath Bool where
  runF IsImageFilename _path = undefined

data ConvertedImageFilename = ConvertedImageFilename deriving (Show)
instance IsF ConvertedImageFilename FilePath FilePath where
  runF ConvertedImageFilename _path = undefined


class (SourceState a, Show f) => IsFIO f a b | f -> a b where
  runFIO :: f -> a -> IO b

data ListDirectory = ListDirectory deriving (Show)
instance IsFIO ListDirectory FilePath [FilePath] where
  runFIO ListDirectory _path = undefined

data OpenImage = OpenImage deriving (Show)
instance IsFIO OpenImage FilePath Image where
  runFIO OpenImage _path = undefined

data ConvertImage = ConvertImage deriving (Show)
instance IsFIO ConvertImage Image Image where
  runFIO ConvertImage _image = undefined

data SaveFile = SaveFile deriving (Show)
instance IsFIO SaveFile (String, FilePath) () where
  runFIO SaveFile _source = undefined

data RunPandoc = RunPandoc deriving (Show)
instance IsFIO RunPandoc String String where
  runFIO RunPandoc _source = undefined
